package com.example.channel

import android.os.Handler
import android.util.Log
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import java.lang.NullPointerException

class MethodCallHandlerExample : MethodChannel.MethodCallHandler {
    companion object {
        internal const val METHOD_CHANNEL_KEY = "example.flutter.test/method_channel"
    }

    override fun onMethodCall(call: MethodCall, result: MethodChannel.Result) {
        Log.d("Android", "MethodChannel onMethodCall called : " + call.method)
        if (call.method == "method_now") {
            result.success(0)
        } else if (call.method == "method_delay") {
            val delayMillis = 1000L;
            Handler().postDelayed(
                    {
                        Log.d("Android", "MethodChannel onMethodCall result callback")
                        result.success(delayMillis)
                    }, delayMillis)
        } else if (call.method == "function_no_implemented") {
            result.notImplemented()
        } else if (call.method == "convert_error") {
            result.success("return String")
        } else if (call.method == "native_return_error") {
            result.error("errorCode_1234", "message_1234", "errorDetails_1234")
        } else if (call.method == "native_runtime_crash") {
            throw NullPointerException("test native runtime exception")
            result.success( null)
        }
        else {
            result.notImplemented()
        }
    }
}