package com.example.channel

import android.util.Log
import com.example.example.MyApp
import com.example.utils.SpUtil
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel

class SettingMethodCallHandler : MethodChannel.MethodCallHandler {

    companion object {
        internal const val METHOD_CHANNEL_KEY = "example.flutter.settings/method_channel"
    }

    override fun onMethodCall(call: MethodCall, result: MethodChannel.Result) {
        Log.d("Android", "MethodChannel onMethodCall called : " + call.method)
        if (call.method == "update_settings") {
            val appId = call.argument<String>("appId")
            val reportUrl = call.argument<String>("reportUrl")
            SpUtil.setAppIdAndReportUrl(MyApp.getContext(), appId, reportUrl)
        } else if (call.method == "getAppId") {
            result.success(SpUtil.getAppId(MyApp.getContext()))
        } else if (call.method == "getReportUrl") {
            result.success(SpUtil.getReportUrl(MyApp.getContext()))
        } else {
            result.notImplemented()
        }
    }
}