package com.example.channel

import android.os.Handler
import android.util.Log
import io.flutter.plugin.common.EventChannel

class StreamHandlerExample : EventChannel.StreamHandler {
    companion object {
        internal const val EVENT_CHANNEL_KEY = "example.flutter.test/event_channel"
    }

    var eventSink: EventChannel.EventSink? = null

    override fun onListen(arguments: Any?, events: EventChannel.EventSink?) {
        eventSink = events
        Log.d("Android", "EventChannel onListen called : " + arguments.toString())
        val delayMillis = 1000L;
        Handler().postDelayed(
                {
                    Log.d("Android", "EventChannel onListen result callback")
                    eventSink?.success(delayMillis)
                }, delayMillis)
    }

    override fun onCancel(arguments: Any?) {
        Log.w("Android", "EventChannel onCancel called : " + arguments.toString())
    }
}