#import "AppDelegate.h"
#import "GeneratedPluginRegistrant.h"
#import <RangersAppLog/BDAutoTrack.h>
#import <RangersAppLog/BDAutoTrackConfig.h>
#import <RangersAPM+Flutter.h>
#import <RangersAPM+PrivatizationDeployment.h>
#import <Flutter/Flutter.h>
@implementation AppDelegate

- (BOOL)application:(UIApplication *)application
    didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
  [GeneratedPluginRegistrant registerWithRegistry:self];
  // Override point for customization after application launch.

  FlutterViewController* controller = (FlutterViewController*)self.window.rootViewController;
  FlutterMethodChannel* settingsChannel = [FlutterMethodChannel
                                            methodChannelWithName:@"example.flutter.settings/method_channel"
                                            binaryMessenger:controller];
    [settingsChannel setMethodCallHandler:^(FlutterMethodCall* call, FlutterResult result) {
        NSString *method = [call method];
            NSDictionary *arguments = [call arguments];
        
      if ([@"update_settings" isEqualToString: method]) {
          NSString *appId = arguments[@"appId"];
          NSString *reportUrl = arguments[@"reportUrl"];
          [[NSUserDefaults standardUserDefaults] setValue:appId forKey: @"appId"];
          [[NSUserDefaults standardUserDefaults] setValue:reportUrl forKey: @"reportUrl"];
          result(@YES);
      } else if ([@"getAppId" isEqualToString: method]) {
          result(getAppId());
      } else if ([@"getReportUrl" isEqualToString:call.method]) {
          result(getReportUrl());
      } else {
        result(FlutterMethodNotImplemented);
      }
    }];

    FlutterMethodChannel* testChannel = [FlutterMethodChannel
                                       methodChannelWithName:@"example.flutter.test/method_channel"
                                       binaryMessenger:controller];
    [testChannel setMethodCallHandler: ^(FlutterMethodCall* call, FlutterResult result) {
        NSString *method = [call method];
        if ([@"method_now" isEqualToString: method]) {
            result(@(1));
        } else if ([@"method_delay" isEqualToString: method]) {
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                result(@(1));
            });
        } else {
            result(FlutterMethodNotImplemented);
        }
    }];
    
    FlutterEventChannel* eventChannel = [FlutterEventChannel
                                       eventChannelWithName:@"example.flutter.test/event_channel"
                                       binaryMessenger:controller];
    [eventChannel setStreamHandler:self];
    
  
  NSString *appId = getAppId();
  NSString *channel = @"App Store";
  NSString *userId = @"98765";
  NSString *reportUrl = getReportUrl();

  //初始化RangersAppLog
  BDAutoTrackConfig *applogConfig = [BDAutoTrackConfig configWithAppID:appId launchOptions:launchOptions];
  applogConfig.channel = channel;
  [BDAutoTrack startTrackWithConfig:applogConfig];

  //初始化APMInsight
  RangersAPMConfig *apmConfig = [RangersAPMConfig configWithAppID:appId];
  apmConfig.channel = channel;
  apmConfig.deviceIDSource = RAPMDeviceIDSourceFromRAppLog;

  [RangersAPM startWithConfig:apmConfig];
  [RangersAPM setUserID: userId];
  if (![reportUrl isEqualToString: @"默认值"]) {
    //调用此接口设置您私有化部署的域名
    NSLog(@"私有化部署地址为：%@", reportUrl);
    [RangersAPM setupRequestURLWithUserDomain: reportUrl withConfig: apmConfig];
  }
  return [super application:application didFinishLaunchingWithOptions:launchOptions];
}

static NSString *getAppId() {
    NSString *appId = [[NSUserDefaults standardUserDefaults] valueForKey: @"appId"];
    if (appId == nil) {
        appId = @"187277";
    }
    return appId;
}

static NSString *getReportUrl() {
    NSString *reportUrl = [[NSUserDefaults standardUserDefaults] valueForKey: @"reportUrl"];
    if (reportUrl == nil) {
        reportUrl = @"默认值";
    }
    return reportUrl;
}

- (FlutterError* _Nullable)onListenWithArguments:(id _Nullable)arguments eventSink:(FlutterEventSink)eventSink {
    NSLog(@"abc");
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        eventSink(@(1000));
    });
    return nil;
}
 
- (FlutterError* _Nullable)onCancelWithArguments:(id _Nullable)arguments {
    return nil;
}

@end
