import 'package:flutter/material.dart';

import '../pages/network_test/http_monitor_page.dart';
import '../pages/channel_test/channel_test_page.dart';
import '../pages/error_test/build_error_page.dart';
import '../pages/error_test/error_router_test/first_page.dart';
import '../pages/error_test/error_router_test/second_page.dart';
import '../pages/error_test/error_router_test/third_page.dart';
import '../pages/error_test/error_test_page.dart';
import '../pages/fluency_test/fluency_test_page.dart';
import '../pages/fluency_test/lottie_test_page.dart';
import '../pages/list_page_test/first_page.dart';
import '../pages/list_page_test/second_page.dart';
import '../pages/list_page_test/third_page.dart';
import '../pages/page_load_test/load_test_page.dart';
import '../pages/page_load_test/loading_page.dart';
import '../pages/setting/setting_page.dart';
import 'widgets.dart';

Map<String, WidgetBuilder> generateRoutes() {
  return <String, WidgetBuilder>{
    '/setting': (BuildContext context) => SettingPage(),
    '/error_test': (BuildContext context) => ErrorTestPage(),
    '/error_test/build_error_page': (BuildContext context) => BuildErrorPage(),
    '/error_test/error_router_test/first_page': (BuildContext context) => ErrorRouterTestFirstPage(),
    '/error_test/error_router_test/second_page': (BuildContext context) => ErrorRouterTestSecondPage(),
    '/error_test/error_router_test/third_page': (BuildContext context) => ErrorRouterTestThirdPage(),
    '/page_load_test': (BuildContext context) => LoadTestPage(),
    '/page_load_test/load_state_test_page': (BuildContext context) => LoadStatePage(),
    '/fluency_test': (BuildContext context) => FluencyTestPage(),
    '/fluency_test/lottie_test_page': (BuildContext context) => LottieTestPage(),
    '/channel_test': (BuildContext context) => ChannelTestPage(),
    '/list_page_test/first_page': (BuildContext context) => FirstListPage(),
    '/list_page_test/second_page': (BuildContext context) => SecondListPage(),
    '/list_page_test/third_page': (BuildContext context) => ThirdListPage(),
    '/showDialog': (BuildContext context) => buildDialog(context),
    '/network_test': (_) => HttpMonitorPage(),
  };
}