import 'dart:io';

import 'package:ve_apm/src/core/apm_navigator_observer.dart';
import 'package:ve_apm/src/core/constants.dart';
import 'package:ve_apm/src/plugin/apm_insight.dart';

import '../utils/log.dart';

num logId = 0;

///
class LogSend {

  static Future<void> reportLog(
      Map<String, dynamic> extraBody, bool isCrash) async {
    if (Platform.isAndroid || Platform.isIOS) {
      if (isCrash) {
        logRelease('method: LogSend.reportLog, step: ApmInsight.reportDartError param: $extraBody');
        ApmInsight.reportDartError(extraBody);
      } else {
        logRelease('method: LogSend.reportLog, step: ApmInsight.reportToInsight, param: $extraBody');
        ApmInsight.reportToInsight(extraBody);
      }
    } else {
      Map<String, dynamic>? logData;
      if (!isCrash) {
        extraBody[KEY_FLT_CATEGORY] = {"flt_pid": ApmNavigatorObserver.instance.getCurrentRouteName()};
        extraBody["log_type"] = "service_monitor";
        extraBody["seq_no"] = logId++;
        logData = <String, dynamic> { KEY_DATA: [extraBody],};
      } else {
        logData = extraBody;
        logData[KEY_IS_DART] = 1;
      }
      _reportLogDart(logData, isCrash);
    }
  }

  static void _reportLogDart(
      Map<String, dynamic> extraBody, bool isCrash) async {
    // todo implement
  }
}
