import 'package:ve_apm/src/errortrace/apm_error_trace.dart';
import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

Widget defaultApmErrorWidgetBuilder(FlutterErrorDetails details) {
  return LayoutBuilder(
    builder: (BuildContext context, BoxConstraints constraints) {
      ApmErrorTrace.instance.updateWidgetErrorInfoFunc();
      return _defaultErrorWidgetBuilder(details);
    },
  );
}

Widget _defaultErrorWidgetBuilder(FlutterErrorDetails details) {
  String message = '';
  assert(() {
    message = _stringify(details.exception) +
        '\nSee also: https://flutter.dev/docs/testing/errors';
    return true;
  }());
  final Object exception = details.exception;
  return ErrorWidget.withDetails(
      message: message, error: exception is FlutterError ? exception : null);
}

String _stringify(Object exception) {
  try {
    return exception.toString();
  } catch (e) {
// intentionally left empty.
  }
  return 'Error';
}
