import 'package:ve_apm/src/perf/page_load_data_manager.dart';

class AppContext {
  num launchStartTime = 0;
  // late TraceCallback traceCallback;

  static AppContext? _instance;

  static AppContext get instance => _instance ??= AppContext._internal();

  AppContext._internal();

  /// calc app load cost time, start: main,  end: fp
  /// not launch this term
  void appFpFinished() {
    // num firstFrameTime = new DateTime.now().millisecondsSinceEpoch;
    // Future.delayed(Duration(milliseconds: 5000), () {
    //   reportEvent(KEY_APP_LOAD, metric: {"duration": firstFrameTime - launchStartTime});
    // });
  }
  /// record page pv, and calc page bounce rate
  void pageLaunch(String page, int routeHashCode, num pageDidPushTime) {
    PageLoadDataManager.instance.joinPageLoadData(routeHashCode, page, pageDidPushTime);
  }

  void pageFpFinished(int routeHashCode){
    PageLoadDataManager.instance.updatePageLoadData(routeHashCode, (pageLoadData) {
      pageLoadData.fp = DateTime.now().millisecondsSinceEpoch - pageLoadData.pageDidPushTime;
    });
  }

  void pageFcpFinished(int routeHashCode) {
    PageLoadDataManager.instance.updatePageLoadData(routeHashCode, (pageLoadData) {
      pageLoadData.fcp = DateTime.now().millisecondsSinceEpoch - pageLoadData.pageDidPushTime;
    });
  }

  void pageFmpFinished(int routeHashCode, String fmpType, {num fmpTime = -1}) {
    if (fmpTime < 0) {
      fmpTime = DateTime.now().millisecondsSinceEpoch;
    }
    PageLoadDataManager.instance.updatePageLoadData(routeHashCode, (pageLoadData) {
      pageLoadData.fmp = fmpTime - pageLoadData.pageDidPushTime;
      pageLoadData.fmpType = fmpType;
    });
  }
}