import 'package:ve_apm/src/core/constants.dart';
import 'package:ve_apm/src/core/apm_log_report.dart';
import 'package:ve_apm/src/utils/log.dart';

class ApmReporter {

  ApmReporter._internal();

  static ApmReporter? _instance;

  static ApmReporter get instance => _instance ??= ApmReporter._internal();

  Future<void> reportEvent(String eventName,
      {num? timestamp,
        Map<String, dynamic>? category,
        Map<String, dynamic>? metric,
        Map<String, dynamic>? extra}) async {
    // assert(Fpm.isInit);
    innerUseReportEventNoPublic(eventName,
        timestamp: timestamp, category: category, metric: metric, extra: extra);
  }

  /// 仅供SDK内部使用
  Future<void> innerUseReportEventNoPublic(String eventName,
      {num? timestamp,
        Map<String, dynamic>? category,
        Map<String, dynamic>? metric,
        Map<String, dynamic>? extra}) async {
    Map<String, dynamic> logItem = <String, dynamic>{
      "timestamp": timestamp ?? new DateTime.now().millisecondsSinceEpoch,
      "service": eventName,
    };
    if (category != null) {
      logItem[KEY_CATEGORY] = category;
    }
    if (metric != null) {
      logItem[KEY_METRIC] = metric;
    }
    if (extra != null) {
      logItem[KEY_EXTRA] = extra;
    }
    logRelease('method: ApmReporter.innerUseReportEventNoPublic, step: LogSend.reportLog, param: $logItem');
    LogSend.reportLog(logItem, false);
  }

}